﻿Imports Colour_Blocks.ExperienceBar
Imports Colour_Blocks.StatsBar
Imports Colour_Blocks.MainForm

Public Class ColourBlock

    Public thisHealthValue As Integer
    Public HealthMax As Integer

    Public Property MaxHealth() As Integer
        Get
            Return HealthMax
        End Get
        Set(ByVal value As Integer)
            Dim percent As Decimal = HealthValue / value

            HealthMax = value

            If percent = 1 Then
                Me.BackgroundImage = My.Resources.health_100
            ElseIf percent >= 0.9 Then
                Me.BackgroundImage = My.Resources.health_90
            ElseIf percent >= 0.8 Then
                Me.BackgroundImage = My.Resources.health_80
            ElseIf percent >= 0.7 Then
                Me.BackgroundImage = My.Resources.health_70
            ElseIf percent >= 0.6 Then
                Me.BackgroundImage = My.Resources.health_60
            ElseIf percent >= 0.5 Then
                Me.BackgroundImage = My.Resources.health_50
            ElseIf percent >= 0.4 Then
                Me.BackgroundImage = My.Resources.health_40
            ElseIf percent >= 0.3 Then
                Me.BackgroundImage = My.Resources.health_30
            ElseIf percent >= 0.2 Then
                Me.BackgroundImage = My.Resources.health_20
            ElseIf percent >= 0.1 Then
                Me.BackgroundImage = My.Resources.health_10
            End If
        End Set
    End Property

    Public Property HealthValue() As Integer
        Get
            Return thisHealthValue
        End Get
        Set(ByVal value As Integer)
            Dim percent As Decimal = value / MaxHealth

            thisHealthValue = value

            If percent = 1 Then
                Me.BackgroundImage = My.Resources.health_100
            ElseIf percent >= 0.9 Then
                Me.BackgroundImage = My.Resources.health_90
            ElseIf percent >= 0.8 Then
                Me.BackgroundImage = My.Resources.health_80
            ElseIf percent >= 0.7 Then
                Me.BackgroundImage = My.Resources.health_70
            ElseIf percent >= 0.6 Then
                Me.BackgroundImage = My.Resources.health_60
            ElseIf percent >= 0.5 Then
                Me.BackgroundImage = My.Resources.health_50
            ElseIf percent >= 0.4 Then
                Me.BackgroundImage = My.Resources.health_40
            ElseIf percent >= 0.3 Then
                Me.BackgroundImage = My.Resources.health_30
            ElseIf percent >= 0.2 Then
                Me.BackgroundImage = My.Resources.health_20
            ElseIf percent >= 0.1 Then
                Me.BackgroundImage = My.Resources.health_10
            End If

        End Set
    End Property


    Private Sub DamageTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DamageTimer.Tick
        If myAmmo > 0 Then
            myAmmo -= 1
            Dim tempCritical As Decimal
            Dim critical As Boolean
            Dim rn As New Random
            Dim i As Integer
            criticalPercent = myCriticalStrike / myLevel * 1.4
            tempCritical = criticalPercent * 100
            i = rn.Next(0, 10000)
            If i <= tempCritical Then
                Dim tempAccuracy As Decimal
                Dim x As Decimal
                accuracyPercent = myAccuracy / myLevel * 1.6
                tempAccuracy = accuracyPercent / 100
                x = tempAccuracy + 2
                critical = True
                myDamage *= x
            Else
                critical = False
                myDamage *= 1
            End If

            If myDamage >= HealthValue Then
                If Me.BackColor = Color.Black Then
                    deathAvoided += 1
                    NewGame.DeathTime.Enabled = False
                End If

                Me.Hide()
                DamageTimer.Enabled = False
                DealingTimer.Enabled = False
                Levelling.WieldReward(Level)
                NewGame.newStats.UpdateValues()
                NewGame.newExperienceBar.UpdateValues()
                blocksDestroyed += 1
            Else
                HealthValue = HealthValue - myDamage
                NewGame.newStats.UpdateValues()
            End If

            If critical = True Then
                myDamage /= 2
            End If

            tempCritical = 0

        Else

        End If
    End Sub

    Private Sub ColourBlock_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        DamageTimer.Enabled = True


    End Sub

    Private Sub ColourBlock_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseUp
        DamageTimer.Enabled = False


    End Sub

    Public ReadOnly Property Level() As Integer
        Get
            Return myLevel
        End Get
        
    End Property

    Private Sub DealingTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DealingTimer.Tick
        Dim dmg As Integer = Levelling.blockDamage
        Dim i As Decimal
        Dim tempPercent As Decimal
        defensePercent = myDefense / myLevel * 2
        tempPercent = defensePercent
        tempPercent /= 100
        i = 1 - tempPercent
        dmg *= i

        myHealthValue -= dmg
        NewGame.newStats.UpdateValues()

        dmg = Levelling.blockDamage
        tempPercent = 0

    End Sub

    Private Sub ColourBlock_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim tempHaste As Decimal
        Dim i As Decimal
        hastePercent = myHaste / myLevel * 1.2
        tempHaste = hastePercent / 100
        i = 1 - tempHaste
        myFireRate *= i
        DamageTimer.Interval = myFireRate
        DealingTimer.Enabled = True
        If BackColor = Color.Black Then
            Levelling.GetHealthDamageValue(Level + 1)
        Else
            Levelling.GetHealthDamageValue(Level)
        End If
        MaxHealth = Levelling.blockHealth
        HealthValue = Levelling.blockHealth

    End Sub

    Public Sub PauseTimers()
        Me.Enabled = False
        DealingTimer.Enabled = False
    End Sub

    Public Sub PlayTimers()
        If Me.Visible = True Then
            Me.Enabled = True
            DealingTimer.Enabled = True
        End If
    End Sub



End Class
